##############################################################################
#
# Copyright (c) 2001, 2002 Zope Corporation and Contributors.
# All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
# 
##############################################################################
"""A simple implementation of a Message Catalog. 

$Id: GettextMessageCatalog.py,v 1.2 2002/08/23 22:49:02 lalo Exp $
"""

from gettext import GNUTranslations

class GettextMessageCatalog:
    """ """

    def __init__(self, path_to_file):
        """Initialize the message catalog"""
        self._path_to_file = path_to_file
        self.__translation_object = None
        self._prepareTranslations()
    

    def _prepareTranslations(self):
        """ """
        if self.__translation_object is None:
            file = open(self._path_to_file, 'r')
            tro = GNUTranslations(file)
            file.close()
            self._language = tro._info.get('language', None)
            self._domain = tro._info.get('domain', None)
            if self._language is None or self._domain is None:
                raise ValueError, 'potfile has no metadata'
            self.__translation_object = tro
            

    def getMessage(self, id):
        """
        """
        self._prepareTranslations()
        msg = self.__translation_object.ugettext(id)
        if msg == id:
            raise KeyError
        return msg

    def queryMessage(self, id, default=None):
        """
        """
        self._prepareTranslations()
        text = self.__translation_object.ugettext(id)
        if text != id:
            return text
        if default is None:
            default = id
        return default

    def getLanguage(self):
        """
        """
        return self._language
        
    def getDomain(self):
        """
        """
        return self._domain

    def getIdentifier(self):
        """
        """
        return self._path_to_file
        
    #
    ############################################################
